 /*
 * FILE								: simhei24.c
 * DESCRIPTION				: This file is iHMI43 simhei24.
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 *
 * create.
 * -------------------
 */

//---------------- Include files ------------------------//

#include <string.h>
#include "..\config\config.h"
#include "..\include\font.h"
#include "..\fatfs\ff.h"

//---------------- Function Prototype -------------------//
static int get(FONT_MATRIX_T *f);
//---------------- Variable -----------------------------//

DOUBLE_BYTE_FONT_T simhei24 = {
	.name = "Simhei 24 ",
	.id = FONT_UNREGISTERED,
	.height = 32,
	.width = 32,
	.dat = NULL,
	.get_matrix = get,
	.pre = NULL,
	.next = NULL
};

static FIL fil;
//-----------------Function------------------------------//
/*
 * Name								: get
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int
get(FONT_MATRIX_T *f)
{
	unsigned long int offset;
	static int first = 0;
	unsigned int counter;

		if(first == 0){ 
	f_open(&fil,"0:/system/yahei32",FA_READ);
 	first = 1;
	}
	
	offset = f->character[0];
	offset -= 0xa1;
	//offset -= 15;
	offset *= 94;
	offset += f->character[1];
	offset -= 0xa1;
	offset *= 128;

	f->direction = DIRECTION_H;
	f->height = simhei24.height;
	f->width = simhei24.width;
	
	f_lseek(&fil,offset);


	f_read(&fil,font_buffer,128,&counter);

	//flash.read_72(offset + SIMHEI24_ADDRESS_BASE, font_buffer);
	f->dat = font_buffer;

	return 0;
}

