/*
 * File				    : bmp.c
 * Description		: ---
 * Author			    : XiaomaGee@Gmail.com
 * Copyright		  :
 *
 * History
 **--------------------
 * Rev				    : 0.00
 * Date				    : 08/12/2012
 *
 * create.
 **--------------------
 */
//----------------- Include files ------------------------//
#include <stdio.h>
#include <math.h>
#include "..\include\bmp.h"
#include "..\fatfs\ff.h"
#include "..\include\flash.h"
#include "..\include\color.h"
#include "..\include\evtft.h"

//----------------- Function Prototype -------------------//
static int get_header_info(char * file, BMP_MASK_T *);
static int show(char * file, int x, int y);
static int capture(void);
static FIL f;

//----------------- Variable -----------------------------//
BMP_T bmp = {
	.header = get_header_info,
	.show = show,
	.capture = capture
};

//----------------- Function -----------------------------//
/*
 * File								: get_header_info
 * Description				: ---
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 *--------------------
 * Rev								: 0.00
 * Date								: 05/9/2012
 *
 * create.
 *--------------------
 */	   
static int
get_header_info(char * file, BMP_MASK_T *h)		     	       //ȡļͷϢ
{
	FRESULT res;

	char *p = (char*)h;
	unsigned int counter;

	res = f_open(&f, file, FA_READ);                        //һbmpļͷ
	if (res != FR_OK) return -1;                            //򷵻-1

	res = f_read(&f, p, sizeof(BMP_MASK_T), &counter);      //bmpļͷĳ
	if (res != FR_OK) return -1;                            //򷵻-1

	f_close(&f);                                            //رļ

	if (h->type[0] != 'B' || h->type[1] != 'M') return -1;  //λͼļͣΪBM

	return 0;
}

/*
 * File								: show
 * Description				: ---
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 *--------------------
 * Rev								: 0.00
 * Date								: 05/9/2012
 *
 * create.
 *--------------------
 */	   
static int
show(char * file, int x, int y)         //ʾͼƬ
{
	int i, j;
	int line_byte;
	unsigned int counter;
	char buffer[LINE_PIXEL * 3];
	unsigned short int *p;
	unsigned short int a, b;
	unsigned char color_table[1024];
	unsigned char c;
//	BMP_HEADER_T bh;
	BMP_MASK_T bh;

	if (get_header_info(file, &bh) != 0) return -1;                         //һbmpļͷ

	if (bh.compression == BI_RLE4 || bh.compression == BI_RLE8) return -1;  //ʱ֧ѹ

	f_open(&f, file, FA_READ); 			//bmpļ

	switch (bh.bit_count) {					//ѡλͼ
	case 1: 								        //ɫλͼ	
		f_lseek(&f,0x36);					    //ƶһ򿪵ļļָ
		f_read(&f, color_table, 2 * 4, &counter);   

		line_byte = ceil(bh.width / 8);

		if (line_byte % 4) line_byte = ((line_byte / 4) + 1) * 4;  

		f_lseek(&f, bh.offset);

		for (i = 0; i < bh.height; i++) {
			f_read(&f, buffer, line_byte, &counter);

			lcd_csrx(x);                        //set x csr
			lcd_csry(y + bh.height - i - 1);  	//set y csr

			lcd_ctl.b.csrmode = CSRMODE_H;      //set csr increase direction
			lcd_ctl(lcd_ctl.w);
 
			for (j = 0; j < bh.width; j++) {
				if (buffer[j / 8] & 1 << (7 - j % 8)) lcd_data(make_rgb565(color_table[6], color_table[5], color_table[4]));
				else lcd_data(make_rgb565(color_table[2], color_table[1], color_table[0]));
			}
		}
		break;
	case 4:                                           //4λͼ  16ɫ
		f_lseek(&f, 0x36);
		f_read(&f, color_table, 16 * 4, &counter);

		line_byte = ceil(bh.width / 2);

		if (line_byte % 4) line_byte = ((line_byte / 4) + 1) * 4;

		f_lseek(&f, bh.offset);

		for (i = 0; i < bh.height; i++) {
			f_read(&f, buffer, line_byte, &counter);

			lcd_csrx(x);		                   //set x csr
			lcd_csry(y + bh.height - i - 1);   //set y csr

			lcd_ctl.b.csrmode = CSRMODE_H;     //set csr increase direction
			lcd_ctl(lcd_ctl.w);

			for (j = 0; j < bh.width; j++) {
				if (j % 2) c = buffer[j / 2] & 0x0f;
				else c = buffer[j / 2] >> 4;

				lcd_data(make_rgb565(color_table[c * 4 + 2], color_table[c * 4 + 1], color_table[c * 4 + 0]));
			}
		}
		break;

	case 8:                                          //8λͼ   256ɫ
		f_lseek(&f, 0x36);

		f_read(&f, color_table, 256 * 4, &counter);          

		line_byte = bh.width;                                   

		if (line_byte % 4) line_byte = ((line_byte / 4) + 1) * 4;

		f_lseek(&f, bh.offset);

		for (i = 0; i < bh.height; i++) {
			f_read(&f, buffer, line_byte, &counter);

			lcd_csrx(x);                                           //set x csr
			lcd_csry(y + bh.height - i - 1);                       //set y csr

			lcd_ctl.b.csrmode = CSRMODE_H;                         //set csr increase direction
			lcd_ctl(lcd_ctl.w);

			for (j = 0; j < bh.width; j++) {
				c = buffer[j];

				lcd_data(make_rgb565(color_table[c * 4 + 2], color_table[c * 4 + 1], color_table[c * 4 + 0]));
			}
		}
		break;
	case 16:                            //16λͼ  64kɫ߲ɫ
		line_byte = bh.width * 2;

		if (line_byte % 4) line_byte = ((line_byte / 4) + 1) * 4;

		f_lseek(&f, bh.offset);

		p = (unsigned short int*)buffer;

		for (i = 0; i < bh.height; i++) {
			f_read(&f, buffer, line_byte, &counter);

			lcd_csrx(x);                                //set x csr
			lcd_csry(y + bh.height - i - 1);            //set y csr

			lcd_ctl.b.csrmode = CSRMODE_H;              //set csr increase direction
			lcd_ctl(lcd_ctl.w);

 			for (j = 0; j < bh.width; j++) {
				if (bh.compression == BI_BITFIELDS ) {
					
					if(bh.mask == 0xF800) lcd_data(p[j]);
					
					else {
					a = (p[j] << 1) & 0xf800;
					b = (p[j] << 1) & 0x07c0;
					lcd_data((p[j] & 0x1f) | a | b);
					}
				}
				
				if (
					bh.compression == BI_RGB
					) {
					a = (p[j] << 1) & 0xf800;
					b = (p[j] << 1) & 0x07c0;
					lcd_data((p[j] & 0x1f) | a | b);
				}		
			}
		}

		break;
	case 24:										//24λͼ  16Mɫ

		line_byte = bh.width * 3;
		if (line_byte % 4) line_byte = ((line_byte / 4) + 1) * 4;
		f_lseek(&f, bh.offset);

		for (i = 0; i < bh.height; i++) {
			f_read(&f, buffer, line_byte, &counter);

			lcd_csrx(x);                            //set x csr
			lcd_csry(y + bh.height - i - 1);        //set y csr

			lcd_ctl.b.csrmode = CSRMODE_H;          //set csr increase direction
			lcd_ctl(lcd_ctl.w);

			for (j = 0; j < bh.width; j++) {
			lcd_data(make_rgb565(buffer[j * 3 + 2], buffer[j * 3 + 1], buffer[j * 3]));
			}
		}

		break;
	case 32:
		goto aa;
	}

	f_close(&f);

	return 0;

 aa:	f_close(&f);

	return -1;
}

/*
 * File								: judge_fname
 * Description				: ---
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 *--------------------
 * Rev								: 0.00
 * Date								: 05/9/2012
 *
 * create.
 *--------------------
 */	   
static int judge_fname(void)                             //½ļȡ
{
	int i = 0;
	char buffer[20];

	do {
		sprintf(buffer, "0:/capture/%d.bmp", i);             //ʾ

		if (f_open(&f, buffer, FA_READ) != FR_OK) return i;  //һļûо½һ
		f_close(&f);
		i++;
	} while (1);
}

/*
 * File								: capture
 * Description				: ---
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 *--------------------
 * Rev								: 0.00
 * Date								: 05/9/2012
 *
 * create.
 *--------------------
 */	   
static int
capture(void)                            //
{
	int i, j;
	DIR dir;
	char buffer[20];
	char dbuffer[480 * 2];                  
	unsigned short int *p;
	unsigned int counter;
	const char palette[16] = {
		0x00, 0xf8, 0x00, 0x00,              //RED
		0xe0, 0x07, 0x00, 0x00,              //GREEN
		0x1f, 0x00, 0x00, 0x00,              //BLUE
		0x00, 0x00, 0x00, 0x00               //AL
	};
	BMP_HEADER_T bh;
	
	//set bmp header infomationbmpļͷϢ
	bh.type[0] = 'B';						//λͼļͱΪBM
	bh.type[1] = 'M';
	bh.file_size = 0x3fc48;			//480*272 16bitλͼļĴСֽΪλ
	bh.reserved = 0;						//ͼļ֣Ϊ0
	bh.offset = 0x46;						//λͼݵʼλãλͼ
	bh.header_info_size = 0x28;	//ļͷƫʾֽΪλ

	bh.width = 480;							//λͼĿȣΪλ
	bh.height = 272;						//λͼĸ߶ȣΪλ

	bh.planes = 1;							//Ŀ豸ļ𣬱Ϊ1
	bh.bit_count = 16;          //16bit  //ÿλ1˫ɫ//416ɫ//8256ɫ//24(ɫ֮һ)
	bh.compression = 0x03;			//Bitfields MODEλͼѹͣ0ѹ//18ѹ//24ѹ

	bh.image_size = 0x3fc02;		//λͼĴСֽΪλ
	bh.xpels_per_meter = 0;			//ˮƽֱ
	bh.ypels_per_meter = 0;			//ֱֱ
	bh.color_used = 0;					//ͼʵõɫֵΪ0õɫΪ2
	bh.color_important = 0;     //ͼҪɫֵΪ0ΪеɫҪ
	
	if (f_opendir(&dir, "0:/capture") != FR_OK) f_mkdir("0:/capture");         //򲻿һļ½һļ

	sprintf(buffer, "0:/capture/%d.bmp", judge_fname());                       //ʾbmp

	if (f_open(&f, buffer, FA_CREATE_ALWAYS | FA_WRITE) != FR_OK) return -1;   //

	f_write(&f, (void*)(&bh), sizeof(BMP_HEADER_T), &counter);
	f_write(&f, palette, sizeof(palette), &counter);

	for (i = 271; i >= 0; i--) {
		p = (unsigned short int*)dbuffer;

		for (j = 0; j < 480; j++) {
			lcd_csrx(j);
			lcd_csry(i);
			lcd.get_point(j, i);
			*p++ = lcd.get_point(j, i);
		}
		f_write(&f, dbuffer, 480 * 2, &counter);
	}

	f_close(&f);

	return 0;
}
