 /*
 * FILE								: ads7843.c
 * DESCRIPTION						: This file is iHMI43 ads7843 driver demo.
 * Author							: XiaomaGee@Gmail.com
 * Copyright						:
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 *
 * create.
 * -------------------
 */
	

//-----------------Include files-------------------------//
#include "..\include\usart.h"
#include "..\include\hardware.h"
#include "..\include\spi.h"
#include "..\include\ads7843.h"
#include "..\include\evtft.h"
#include "..\include\font.h"
#include "..\include\systick.h"
#include "..\include\integer.h"

#include "..\config\config.h"
#include "..\fatfs\ff.h"
#include "..\include\touch.h"

#include "stdlib.h"
#include "math.h"
//---------------- Function Prototype ------------------//
static int initialize_ads7843(void);
static int read_x(void);
static int read_y(void);
static int Read_ADS(int *x,int *y);
static int Read_ADS2(int *x,int *y);
static int Convert_Pos(void);
static int Touch_Adjust(void);
static int Draw_Big_Point(int x,int y);
static int acmp(const void *a,const void *b);
static int read_key(void);

//-----------------Variable-----------------------------//  
ADS7843_T ads7843={
	.initialize = initialize_ads7843,
	.read_x = read_x,
	.read_y = read_y,
	.Read_ADS=Read_ADS,
	.Read_ADS2=Read_ADS,
	.Convert_Pos=Convert_Pos,
	.Touch_Adjust=Touch_Adjust,
	.Draw_Big_Point=Draw_Big_Point,
	.read_key = read_key
};

int key_code = 0;
Pen_Holder Pen_Point;//
#define CMD_RDY 0X90  //0B10010000òַʽX
#define CMD_RDX	0XD0  //0B11010000òַʽY   											 
// #define ERR_RANGE 50 //Χ  
// #define NULL 	0 
// #define mmm 	0 

//-----------------Function-----------------------------//

/*
 * Name								: initialize_ads7843
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
 static int 
 initialize_ads7843(void)
{
	TBUSY;		//ʼ
	TIRQ;		//ʼ

	Pen_Point.xfac = XFAC;
	Pen_Point.xoff = XOFF;
	Pen_Point.yfac = YFAC;
	Pen_Point.yoff = YOFF;
  
	return 0;
}

/*
 * Name								: read_key
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int
read_key(void)
{
	key_code = 0;
	TOUCH_LL_T * p = &touch_ll;
	
	Convert_Pos();
	
	while( p != NULL){
			if(
			((Pen_Point.x0 > p -> x0) && (Pen_Point.x0 < p -> x1)) &&
			((Pen_Point.y0 > p -> y0) && (Pen_Point.y0 < p -> y1))
		){
			key_code = p -> event;
			break;
		}
		p = p -> next;	
	}

	return 0;
}

/*
 * Name								: read_x
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int 
read_x(void)
{
//  	int i;
// 	int dat;
//  	unsigned char a,b;
// 	
// 	SPI3_CS_OFF;
// 	spi3.send_data(0XD0);
// 	
//  	for(i=0;i<5000;i++);
//  
//  	a = spi3.send_data(0); 
// 	b = spi3.send_data(0); 

// 	SPI3_CS_ON;
// 	
// 	dat = 0; 
// 	a &= 0x7f;
// 	dat += a;
// 	dat <<= 5;
// 	b >>=3;
// 	dat += b;
//     
//   return dat;  	

	unsigned char buf[3] = {CMD_RDX};
	SPI3_CS_OFF;
 	spi3.write(3,buf); 
	SPI3_CS_ON;
	return (int)(buf[1] << 5) | (buf[2] >> 3); 

}

/*
 * Name								: read_y
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int 
read_y(void)
{
// 	int i;
// 	int dat;
//  	unsigned char a,b;
// 	
// 	SPI3_CS_OFF;
// 	spi3.send_data(0X90);
// 	
// 	for(i=0;i<5000;i++);	 //100000
//   a = spi3.send_data(0);  
// 	b = spi3.send_data(0);
// 	SPI3_CS_ON;

// 	dat = 0; 
// 	a &= 0x7f;
// 	dat += a;
// 	dat <<= 5;
// 	b >>=3;
// 	dat += b;  					   
//   
// 	return dat;	
	
	unsigned char buf[3] = {CMD_RDY};
	SPI3_CS_OFF;
 	spi3.write(3, buf); 
	SPI3_CS_ON;
	return (int)(buf[1] << 5) | (buf[2] >> 3); 	
	
	
}

/*
 * Name								: Read_ADS
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */

static int Read_ADS(int *x,int *y)
{
// 	int xtemp,ytemp;
// 	xtemp=read_x();
// 	ytemp=read_y(); 
// //	if(xtemp<100||ytemp<100)return 0;//ʧ
// 	*x=xtemp;
// 	*y=ytemp;
// 	return 1;//ɹ
	
	*x = read_x();
	*y = read_y(); 

	return 1;//ɹ
}

/*
 * Name								: acmp
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int acmp(const void *a,const void *b)
{
	return(*(int *)a - *(int *)b);
}

/*
 * Name								: Read_ADS2
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */

static int  Read_ADS2(int *x,int *y) 
{
// 	int x1,y1;
//  	int x2,y2;
//  	int flag;    
//     flag=Read_ADS(&x1,&y1);   
//     if(flag==0)return(0);
//     flag=Read_ADS(&x2,&y2);	   
//     if(flag==0)return(0);   
//     if(((x2<=x1&&x1<x2+ERR_RANGE)||(x1<=x2&&x2<x1+ERR_RANGE))//ǰβ+-50
//     &&((y2<=y1&&y1<y2+ERR_RANGE)||(y1<=y2&&y2<y1+ERR_RANGE)))
//     {
//         *x=(x1+x2)/2;
//         *y=(y1+y2)/2;
//         return 1;
//     }
// 		else return 0;	 

	int i;
	int a[10],b[10];
	
	for (i = 0; i < 10; i++)
	{
		while (!Read_ADS(&a[i],&b[i]));
	}
	qsort (a,10,sizeof(a[0]),acmp);
	qsort (b,10,sizeof(b[0]),acmp);
	
	*x = a[5];
	*y = b[5];
	
	return 1;
	
} 
/*
 * Name								: Read_TP_Once
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */			   
 int Read_TP_Once(void)
  {
	int t=0;
	int i=0;	    

	Read_ADS2(&Pen_Point.X,&Pen_Point.Y);
	while((GPIOB->IDR.B.IO0)==0 &&t<=250)	//жϰǷ
	{	Read_ADS2(&Pen_Point.X,&Pen_Point.Y);
		
		t++;
		for(i=0;i<100000;i++);
	};
	if(t>=250)return 0;//2.5s ΪЧ
	else return 1;	
}
/*
 * Name								: Drow_Touch_Point
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
void Drow_Touch_Point(int x,int y)
{
	gui.line(x-12,y,x+13,y,COLOR_RED);//
	gui.line(x,y-12,x,y+13,COLOR_RED);//
	gui.dot(x+1,y+1,COLOR_RED);
	gui.dot(x-1,y+1,COLOR_RED);
	gui.dot(x+1,y-1,COLOR_RED);
	gui.dot(x-1,y-1,COLOR_RED);
	gui.circle(x,y,6,0,COLOR_RED);//Ȧ
}	  
/*
 * Name								: Draw_Big_Point
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int  Draw_Big_Point(int x,int y)
{	 
    
	gui.dot(x,y,COLOR_RED);  //ĵ 
	gui.dot(x+1,y,COLOR_RED);
	gui.dot(x,y+1,COLOR_RED);
	gui.dot(x+1,y+1,COLOR_RED);	
	return 0; 	  	
}
/*
 * Name								: Convert_Pos
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int Convert_Pos(void)  //任
{		 	  
	if(Read_ADS2(&Pen_Point.X,&Pen_Point.Y))
	{
		Pen_Point.x0=Pen_Point.xfac*Pen_Point.X+Pen_Point.xoff;
		Pen_Point.y0=Pen_Point.yfac*Pen_Point.Y+Pen_Point.yoff;  
		
		if(Pen_Point.x0 < 0 )Pen_Point.x0 = 0;
		if(Pen_Point.x0 > 479)Pen_Point.x0 = 479;
		if(Pen_Point.y0 < 0 )Pen_Point.y0 = 0;
		if(Pen_Point.y0 > 271)Pen_Point.y0 = 271;
	}
	return 0;
}	   
  

/*
 * Name								: Touch_Adjust
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */

static int  Touch_Adjust(void)		  //У
{								 
	int pos_temp[4][2];//껺ֵ
	int  cnt=0;	
	double d1,d2;
	double  tem1,tem2;
	double fac; 	   
	cnt=0;				
	lcd.cls(COLOR_WINDOW_BACKGROUND);
	Drow_Touch_Point(20,20);//1 
	Pen_Point.xfac=0;//xfacǷУ׼,У׼֮ǰ!	 
	cnt=0;
	while(1)
	{
		   	  
     if((GPIOB->IDR.B.IO0)==0)//
		{
			if(Read_TP_Once())//õΰֵ
			{  								   
				pos_temp[cnt][0]=Pen_Point.X;
				pos_temp[cnt][1]=Pen_Point.Y;
				cnt++;
			}	
			
			   	 usart1.printf(" (%d  %d)",Pen_Point.X,Pen_Point.Y);

					switch(cnt)
			{			   
				case 1:
					lcd.cls(COLOR_WINDOW_BACKGROUND);// 
					Drow_Touch_Point(450,20);//2	   //450   20
					break;
				case 2:
					lcd.cls(COLOR_WINDOW_BACKGROUND);;// 
					Drow_Touch_Point(20,250);//3		  //20 250
					break;
				case 3:
					lcd.cls(COLOR_WINDOW_BACKGROUND);;// 
					Drow_Touch_Point(450,250);//4    450   250
					break;
				case 4:	 //ȫĸѾõ ж϶ԱǷ
	    		  
					tem1=abs(pos_temp[0][0]-pos_temp[1][0]);//x1-x2
					tem2=abs(pos_temp[0][1]-pos_temp[1][1]);//y1-y2
					tem1*=tem1;
					tem2*=tem2;
					d1=(double)sqrt(tem1+tem2);//õ1,2ľ
					
					tem1=abs(pos_temp[2][0]-pos_temp[3][0]);//x3-x4
					tem2=abs(pos_temp[2][1]-pos_temp[3][1]);//y3-y4
					tem1*=tem1;
					tem2*=tem2;
					d2=(double)sqrt(tem1+tem2);//õ3,4ľ
					fac=d1/d2;
					usart1.printf(" z%f",fac);
					if(fac<0.90||fac>1.10||d1==0||d2==0)//ϸ
					{
						cnt=0;
							lcd.cls(COLOR_WINDOW_BACKGROUND);;// 
						Drow_Touch_Point(20,20);
						continue;
					}
					 						
					tem1=abs(pos_temp[0][0]-pos_temp[2][0]);//x1-x3
					tem2=abs(pos_temp[0][1]-pos_temp[2][1]);//y1-y3
					tem1*=tem1;
					tem2*=tem2;
					d1=(double)sqrt(tem1+tem2);//õ1,3ľ
					
					tem1=abs(pos_temp[1][0]-pos_temp[3][0]);//x2-x4
					tem2=abs(pos_temp[1][1]-pos_temp[3][1]);//y2-y4
					tem1*=tem1;
					tem2*=tem2;
					d2=(double)sqrt(tem1+tem2);//õ2,4ľ
					fac=d1/d2;
					usart1.printf(" x%f",fac);
					if(fac<0.90||fac>1.10)//ϸ
					{
						cnt=0;
						lcd.cls(COLOR_WINDOW_BACKGROUND);// 
						Drow_Touch_Point(20,20);
						continue;
					}//ȷ
								   
					//Խ
					tem1=abs(pos_temp[1][0]-pos_temp[2][0]);//x1-x3
					tem2=abs(pos_temp[1][1]-pos_temp[2][1]);//y1-y3
					tem1*=tem1;
					tem2*=tem2;
					d1=(double)sqrt(tem1+tem2);//õ1,4ľ
	
					tem1=abs(pos_temp[0][0]-pos_temp[3][0]);//x2-x4
					tem2=abs(pos_temp[0][1]-pos_temp[3][1]);//y2-y4
					tem1*=tem1;
					tem2*=tem2;
					d2=(double)sqrt(tem1+tem2);//õ2,3ľ
					fac=d1/d2;
					usart1.printf(" c%f",fac);

					if(fac<0.90||fac>1.10)//ϸ
					{
						cnt=0;
							lcd.cls(COLOR_WINDOW_BACKGROUND);// 
						Drow_Touch_Point(20,20);
						continue;
					}//ȷ
					//
					Pen_Point.xfac=(double)430.0/(pos_temp[1][0]-pos_temp[0][0]);//õxfac		 
					Pen_Point.xoff=(470-Pen_Point.xfac*(pos_temp[1][0]+pos_temp[0][0]))/2.0;//õxoff
						  
					Pen_Point.yfac=(double)230.0/(pos_temp[2][1]-pos_temp[0][1]);//õyfac
					Pen_Point.yoff=(270-Pen_Point.yfac*(pos_temp[2][1]+pos_temp[0][1]))/2.0;//õyoff  
			
// 					usart1.printf(" xxxxxxx   %f   %f   %f  %f ",Pen_Point.xfac,Pen_Point.xoff,Pen_Point.yfac,Pen_Point.yoff);
// 			     	lcd.cls(COLOR_WINDOW_BACKGROUND);//

// 					   	font._default.single_byte = &tahoma26;
// 						s.x =  40;
// 						s.y =  38;
// 						s.color = COLOR_BLACK;
// 						s.space.line = 0;
// 						s.space.word = 0;
// 						s.background_color = COLOR_WINDOW_BACKGROUND ;
// 						s.inverse = NULL;
// 						font.printf(&s," Touch Screen Adjust OK! ");//У
						
		     
					return 0;//У			 
			}  //switch	 
		}	  //for	
 	   }//while	
	 }


