/*
 * FILE								: beep.c
 * DESCRIPTION				: This file is iHMI43 beep driver.
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 *
 * create.
 * -------------------
 */

//---------------- Include files ------------------------//

#include "..\include\hardware.h"
#include "..\include\beep.h"

//---------------- Function Prototype -------------------//

static int initialize(void);
static int frequency(int);


//---------------- Variable -----------------------------//
BEEP_T beep={
	.initialize=initialize,
	.frequency=frequency
};

//-----------------Function------------------------------//
/*
 * Name								: initialize
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * ----------------------
 */
static int
initialize(void)
{

	GPIOB->CRL.B.MODE6 = 0x3;	//	50M
	GPIOB->CRL.B.CNF6  = 0x2;	//  

 	TIM4->CCMR1.B_COMP.CC1S=0;
	TIM4->CCMR1.B_COMP.OC1FE=1;
	TIM4->CCMR1.B_COMP.OC1M=6; //pmw mode 1
	TIM4->CCMR1.B_COMP.OC1PE=1; //auto load

	TIM4->CCR1=TIM4->ARR / 2; //always  50%
    	
	TIM4->PSC=3;

	TIM4->CR1.B.ARPE=1;
  TIM4->CR1.B.DIR=1;
  TIM4->CR1.B.CEN=1;
	
//	TIM4->BDTR.B.MOE=1;
   
	return 0;
}
/*
 * Name								: frequency
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * ----------------------
 */
static int 
frequency(int freq)
{
	
 if(freq == 0) {

	TIM4->CR1.B.CEN=0;
	GPIOB->CRL.B.MODE6 = 0x3;	//	50M
	GPIOB->CRL.B.CNF6  = 0x1;	//
	GPIOB->BSRR.B.CLRIO6=1;
	return 0;
}
		else {
			GPIOB->CRL.B.MODE6 = 0x3;	//	50M
			GPIOB->CRL.B.CNF6  = 0x2;	//
			
		TIM4->ARR=(18000000 /freq); //ԤװĴ
		TIM4->CCR1=TIM4->ARR / 2; //always  50%
		TIM4->CR1.B.CEN=1;
		TIM4->CCER.B.CC1E=1;
 	}

//		TIM4->BDTR.B.MOE=1;
    	
	return 0;
}
