 /*
 * FILE								: ds1302.c
 * DESCRIPTION				: This file is iHMI43 ds1302 driver demo.
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 *
 * create.
 * -------------------
 */

//---------------- Include files ------------------------//

#include "..\include\hardware.h"
#include "..\include\ds1302.h"
#include "..\include\systick.h"

#include <stdio.h>   

//---------------- Function Prototype -------------------//

static int initialize(void);
static int get(RTC_T * r);
static int set(RTC_T * r);
static int judge(void);
							
//---------------- Variable -----------------------------//
 
DS1302_T ds1302 = { 
	.initialize = initialize,
	.get = get,
	.set = set 	
};	  

RTC_T rtc;

/*
 * Name								: bcd2hex
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
unsigned char bcd2hex(unsigned char value)	//ʮתΪʮ
{
	unsigned char i;

	i = value & 0x0f;
	value >>= 4;
	value &= 0x0f;
	value *= 10.0;
	i += value;

	return i;
}
/*
 * Name								: hex2bcd
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
unsigned char hex2bcd(unsigned char value)	//ʮתΪʮ
{
	unsigned char i, j;

	i = value / 10;
	j = value % 10;

	return(j + (i << 4));
}
/*
 * Name								: dly
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
void dly(void) 								 //ʱ10us
{
	int i;

	for (i = 0; i < 1000; i++) ;
}
/*
 * Name								: read_byte
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
unsigned char  read_byte()  					//һֽ
{
	unsigned char i;
	unsigned char dat = 0;

		DS1302_IO_INPUT;

	for (i = 8; i > 0; i--) {
		dat >>= 1;		 						//ACCһ8λĴ

	if(DS1302_IO_DATA){
		dat |= 0x80;
	}
		DS1302_SCLK_ON;
		//  dly();
		DS1302_SCLK_OFF;
		//  dly();
	}

	DS1302_IO_OUTPUT;

	return(dat);
}
/*
 * Name								: write_byte
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int
write_byte(unsigned char tdata)  				//дһֽ
{
	unsigned char i;
	
	for (i = 8; i > 0; i--) {
	 
		if( tdata &0x01) {
		DS1302_IO_ON;
		}else {
		DS1302_IO_OFF;
		}
		DS1302_SCLK_ON;
		//	  dly();
		DS1302_SCLK_OFF;
		//	  dly();
		tdata >>= 1;
	}

	return 0;
}
/*
 * Name								: write_data_ds1302
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int
write_data_ds1302(unsigned char taddr, unsigned char tdata)  //д
{
	DS1302_RST_OFF;
	DS1302_SCLK_OFF;
	DS1302_RST_ON;
	dly();
	
	write_byte(taddr);
	write_byte(tdata);
	dly();
	
	DS1302_RST_OFF;
	DS1302_SCLK_ON;

	return 0;
}
/*
 * Name								: read_data_ds1302
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
unsigned char read_data_ds1302(unsigned char taddr)  		//
{
	unsigned char tdata;

	DS1302_RST_OFF;
	DS1302_SCLK_OFF;
	DS1302_RST_ON;
	dly();
	
	write_byte(taddr);
	tdata = read_byte();
	dly();

	DS1302_RST_OFF;
	DS1302_SCLK_ON;
	return(tdata);
}
/*
 * Name								: set
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int 
set(RTC_T * r)   											//ʱ䣬ֻһΣдڻȡʱ֮ǰ
{
	write_data_ds1302(0x8e, 0x00); 

	write_data_ds1302(0x80, hex2bcd(r->second));
	write_data_ds1302(0x82, hex2bcd(r->minute));
	write_data_ds1302(0x84, hex2bcd(r->hour));
	write_data_ds1302(0x86, hex2bcd(r->day));
	write_data_ds1302(0x88, hex2bcd(r->month));
	write_data_ds1302(0x8A, hex2bcd(r->week));
	write_data_ds1302(0x8C, hex2bcd(r->year));		 	

	write_data_ds1302(0x8e, 0x80);
	
	return 0;    	
}
/*
 * Name								: get
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int 
get(RTC_T * r)  											//ȡʱ
{ 
   r->second = bcd2hex(read_data_ds1302(0x81));
   r->minute = bcd2hex(read_data_ds1302(0x83));
   r->hour = bcd2hex(read_data_ds1302(0x85));
   r->day = bcd2hex(read_data_ds1302(0x87));
   r->month = bcd2hex(read_data_ds1302(0x89));
   r->week = bcd2hex(read_data_ds1302(0x8B));
   r->year = bcd2hex(read_data_ds1302(0x8D));

   return 0;
}
/*
 * Name								: initialize
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int
initialize(void)  											//ʼ
{
	DS1302_RST_OUTPUT;
	DS1302_SCLK_OUTPUT;
	DS1302_IO_OUTPUT;

	DS1302_RST_OFF;
	DS1302_SCLK_OFF;
	DS1302_IO_OFF;
	
	judge();
	
	return 0;
}

/*
 * Name								: DS1302_JUDGE
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int
judge(void)  											//DS1302ʼ
{
	int a=0,b=0;
	
	ds1302.get(&rtc);	
	a = rtc.second;
	
	systick.initialize();
	
	systick.second_flag = 0;
	while(!systick.second_flag);
 	systick.second_flag = 0;
	
	ds1302.get(&rtc);
	b = rtc.second;
	
	if(a == b){
	rtc.year = 12;	//ʱ
	rtc.month = 8;
	rtc.day = 21;

	rtc.second = 10;
	rtc.minute = 43;
	rtc.hour = 9;		  
	ds1302.set(&rtc);		
	}
	return 0;
}

