/*
 * FILE								: i2c.c
 * DESCRIPTION				: This file is iHMI43 nvic driver demo.
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 *
 * create.
 * --------------------
 */

//---------------- Include files ------------------------//

#include "..\include\hardware.h"
#include "..\include\i2c.h"

//---------------- Function Prototype -------------------//

 
static int initialize(void);
static unsigned char read(void);
static int write(unsigned char data);
static int start(void);
static int stop(void);

static int ack(char);
static int read_nbyte(unsigned char sla,unsigned char suba,unsigned char *s,unsigned char no);
static int write_nbyte(unsigned char sla,unsigned char suba,unsigned char *s,unsigned char no);

 
 //---------------- Variable -----------------------------//

MY_I2C_T i2c={
	.initialize=initialize,
	.read=read,
	.write=write,
	.start=start,
	.stop=stop,

	.ack=ack,
 	.read_nbyte=read_nbyte,
	.write_nbyte=write_nbyte
};
 
//-----------------Function------------------------------//

void delay(void)
{
	int i;

	for(i=0;i<100;i++);

}
/*
 * Name								: initialize
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * --------------------
 */

static int initialize(void)
{
	SDA_OUTPUT;
	SCL_OUTPUT;
	
	SDA_ON;
	SCL_ON;
	

	return 0;  
}
/*
 * Name								: start
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * --------------------
 */

static 
int start(void)
{
//	SDA_OUTPUT;

 	SDA_ON;

	delay();

	SCL_ON;
	delay();
	
	SDA_OFF;
	delay();
	
	SCL_OFF;
	delay();


	return 0;

}
/*
 * Name								: stop
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * --------------------
 */
static 
int stop(void)
{
//	SDA_OUTPUT;


 	SDA_OFF;
	delay();

	SCL_ON;

	delay();
	

	SDA_ON;

	delay();

	return 0;
}


/*
 * Name								: ack
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * --------------------
 */
static int
ack(char a)
{
//	SDA_OUTPUT;

	if(a){
		SDA_OFF;
	}else {
		SDA_ON;
	}
	delay();
	SCL_ON;	
	delay();
	SCL_OFF;

	delay();


   	return 0;
};


 
/*
 * Name								: write
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * --------------------
 */

static int
write(unsigned char  data)
{
	unsigned char i=8;

//	SDA_OUTPUT;
 
	for(i=0;i<8;i++) /*Ҫ͵ݳΪ8 λ*/
	{
		if((data<<i)&0x80)SDA_ON; /*жϷλ*/
		else SDA_OFF;
		delay();
		SCL_ON;
		delay();
		SCL_OFF;
	} 
	SDA_INPUT;
	delay();
	
	
	delay();
	SCL_ON;
	
	delay();  
	if(SDA_DATA)i2c.ack_flag=0;
	else i2c.ack_flag=1; /*жǷյӦź*/
	SCL_OFF;
	SDA_OUTPUT;
	delay();
	
	return 0;
}

static unsigned char read(void)
{
	 unsigned char retc;
	 unsigned char BitCnt;
	
	
	retc=0;
	
	SDA_ON; /*Ϊ뷽ʽ*/
	SDA_INPUT;
	
	for(BitCnt=0;BitCnt<8;BitCnt++)
	{
		delay();
		SCL_OFF; /*ʱΪͣ׼λ*/
		delay();
		SCL_ON; /*ʱΪʹЧ*/
		delay();
		retc=retc<<1;
		if(SDA_DATA==1)retc=retc+1; /*λ,յλretc  */
		delay();
	}
	SCL_OFF;
	delay();
	
	SDA_OUTPUT;
	
	return(retc);


}
static int 
read_nbyte(unsigned char sla,unsigned char suba,unsigned char *s,unsigned char no)
{
	unsigned char i;

	i2c.start(); /**/
	i2c.write(sla); /*ַ*/
//	if(i2c.ack_flag==0)return(0);
	i2c.write(suba); /*ӵַ*/
//	if(i2c.ack_flag==0)return(0);
	i2c.start();
	i2c.write(sla+1);
//	if(i2c.ack_flag==0)return(0);
	for(i=0;i<no-1;i++)
	{
	*s=i2c.read(); /**/
	i2c.ack(1); /*;ʹλ*/
	s++;
	}
	*s=i2c.read();
	i2c.ack(0);
	i2c.stop();


return(1);
}
 
static int 
write_nbyte(unsigned char sla,unsigned char suba,unsigned char *s,unsigned char no)
{
	unsigned char i;
	
	i2c.start();
	i2c.write(sla);
 	if(i2c.ack_flag==0) return(0);
	i2c.write(suba);
	if(i2c.ack_flag==0) return(0);

	for(i=0;i<no;i++)
	{
		i2c.write(*s);
		if(i2c.ack_flag==0) return(0);
		s++;
	}
	i2c.stop();

	return(1);
}

