/*
 * File								: lm75.c
 * Description				: This file is iHMI43 lm75 driver demo.
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 *--------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 *
 * create.
 *--------------------
 */
 
//-----------------Include files-------------------------//
 
#include "..\include\hardware.h"
#include "..\include\i2c.h"
#include "..\include\lm75.h"

//----------------Define--------------------------------//

static int initialize(void);
static float read(void);


LM75_T lm75={
	.initialize=initialize,
	.read=read
};
//-----------------Function------------------------------//

/*
 * Name								: initialize
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * --------------------
 */
static int initialize(void)
{

 	i2c.initialize();

	return 0;
} 

/*
 * Name								: read
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * --------------------
 */
static float
read(void)
{
	union{
		unsigned char buf[2];
		short int value;
	}temp;
	float f;
	unsigned char c;


	i2c.read_nbyte(LM75,0,temp.buf,2);

	c=temp.buf[0];
	temp.buf[0]=temp.buf[1];
	temp.buf[1]=c;

	f=temp.value;
	f/=32.0;
	f*=0.125;

	return f;
}

