 /*
 * FILE								: pwm.c
 * DESCRIPTION				: This file is iHMI43 pwm driver demo.
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 *
 * create.
 * -------------------
 */

//---------------- Include files ------------------------//

#include "..\include\hardware.h"
#include "..\include\pwm.h"

//---------------- Function Prototype -------------------//

static int initialize(int /* bl */);
static int open(int);
static int close(void);

static int light=0;


//---------------- Variable -----------------------------//
PWM_T pwm = {
	.initialize = initialize,
	.open = open,
	.close = close
};

//-----------------Function------------------------------//
/*
 * Name								: initialize
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int
initialize(int bl)
{
	float temp = 100 - bl;

	GPIOA->CRH.B.MODE8 = 0x3;       //	50M  //PA6 AS TFT back light
	GPIOA->CRH.B.CNF8 = 0x2;        //  


	TIM1->CCMR1.B_COMP.CC1S = 0;
	TIM1->CCMR1.B_COMP.OC1FE = 1;
	TIM1->CCMR1.B_COMP.OC1M = 6; //pmw mode 1
	TIM1->CCMR1.B_COMP.OC1PE = 1; //auto load

	temp /= 100.0;
	temp *= 20000;		//ԭ65535

	TIM1->ARR = 20000; //ԤװĴ
	TIM1->CCR1 = temp; //

	TIM1->PSC = 3;

	TIM1->CCER.B.CC1E = 1;

	TIM1->CR1.B.ARPE = 1;
	TIM1->CR1.B.DIR = 1;
	TIM1->CR1.B.CEN = 1;
	
	TIM1->BDTR.B.MOE=1;
	
	light = bl;

	return 0;
}
/*
 * Name								: open
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int
open(int value)
{
	int i,j;
	
	for(i=0;i<value;i++){	
	pwm.initialize(i);
	for(j = 0;j < 20000; j ++);
}
	return 0;
}
/*
 * Name								: close
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * -------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * -------------------
 */
static int
close(void)
{
	int i,j;
	int bak = light;
	
	for(i=0;i<bak;i++){	
	pwm.initialize(bak-1- i);
	for(j = 0;j < 20000; j ++);
}

return 0;

}
