/*
 * File								: sd.c
 * Description				: This file is iHMI43 sd card driver.
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 *--------------------
 * Rev								: 0.00
 * Date								: 05/9/2012
 *
 * create.
 *--------------------
 */
 
//-----------------Include files-------------------------//
 
#include "..\include\hardware.h"
#include "..\include\spi.h"
#include "..\include\sd.h"
#include <stdio.h>

//---------------- Function Prototype ------------------//

static int initialize_spi2(void);
static int write(int number, unsigned char * buf);
static unsigned char send_data(unsigned char data);

//-----------------Variable-----------------------------//  
SYS_SPI_T spi2 = {
	.initialize = initialize_spi2,
	.write = write,
	.send_data = send_data
};
//-----------------Function-----------------------------//

/*
 * Name										: initialize_spi2
 * Description						: ---
 * Author									: XiaomaGee.
 *
 * History
 * -----------------------
 * Rev										: 0.00
 * Date										: 03/05/2012
 * 
 * create.
 * ----------------------
 */

static int initialize_spi2(void)
{
	RCC->APB1ENR.B.SPI2EN = 1;

	GPIOB->CRH.B.MODE12 = 0x3;       //NSS 50M
	GPIOB->CRH.B.CNF12= 0x0;        //10ùģʽ
	GPIOB->CRH.B.MODE13 = 0x3;       //CSK 50M
	GPIOB->CRH.B.CNF13 = 0x2;        //10ùģʽ
	GPIOB->CRH.B.MODE15 = 0x3;       //MOSI 50M
	GPIOB->CRH.B.CNF15 = 0x2;        //10ùģʽ

	GPIOB->CRH.B.MODE14 = 0x0;       //MISO
	GPIOB->CRH.B.CNF14 = 0x1;        //01ģʽ(λ״̬)
	//10/ģʽ

	SPI2->CR1.B.BR = 0;             //000 fPCLK/2
	//001 fPCLK/4
	//010 fPCLK/8
	//011 fPCLK/16
	//100 fPCLK/32
	//101 fPCLK/64
	//110 fPCLK/128	36M/128
	//111 fPCLK/256
	SPI2->CR1.B.BIDIMODE = 0;         //0ѡ˫˫ģʽ
	SPI2->CR1.B.CPOL = 0;
	SPI2->CR1.B.CPHA = 0;
	SPI2->CR1.B.DFF = 0;            //1ʹ16λ֡ʽз/գ
																	//0ʹ8λ֡ʽз/գ
	SPI2->CR1.B.LSBFIRST = 0;       //0ȷMSB
	SPI2->CR2.B.SSOE = 1;           //1豸ʱģʽSS
	SPI2->CR1.B.MSTR = 1;           //1Ϊ豸

	SPI2->CR1.B.SSM = 1;
	SPI2->CR1.B.SSI = 1;   //

	SPI2->CR1.B.SPE = 1;            //1SPI豸

	SPI2_CS_ON;

	return 0;
}
/*
 * Name										: send_data
 * Description						: ---
 * Author									: XiaomaGee.
 *
 * History
 * -----------------------
 * Rev										: 0.00
 * Date										: 03/05/2012
 * 
 * create.
 * ----------------------
 */

static unsigned char send_data(unsigned char data)
{
	while (!(SPI2->SR.B.TXE == 1)) ;

	SPI2->DR = data;

	while (!(SPI2->SR.B.RXNE == 1)) ;

	return SPI2->DR;
}
/*
 * Name										: write
 * Description						: ---
 * Author									: XiaomaGee.
 *
 * History
 * -----------------------
 * Rev										: 0.00
 * Date										: 03/05/2012
 * 
 * create.
 * ----------------------
 */

static int write(int number, unsigned char * buf)
{
	int i;

	SPI2_CS_OFF;

	for (i = 0; i < number; i++) buf[i] = send_data(buf[i]);

	SPI2_CS_ON;

	return 0;
}

