/*
 * File								: systick.c
 * Description				: This file is iHMI43 systick.
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 *--------------------
 * Rev								: 0.00
 * Date								: 08/25/2012
 *
 * create.
 *--------------------
 */ 
//---------------- Include files ------------------------//

#include "..\include\hardware.h"
#include "..\include\systick.h"
#include "..\include\beep.h"
#include "..\include\ads7843.h"
#include "..\include\evtft.h"
#include "..\include\font.h"
#include "..\include\systick.h"
#include "..\include\integer.h"
#include "..\fatfs\ff.h"
#include "..\include\key.h"
#include "..\include\ads7843.h"

#include <stdio.h>

//---------------- Function Prototype -------------------//

static int initialize(void);

//---------------- Variable -----------------------------//

SYS_TICK_T systick={
	.initialize=initialize,
	.counter=0	
};

int event;

//-----------------Function------------------------------//
/*
 * Name								: initialize
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * --------------------
 */
static int
initialize(void)
{	
	SYSTICK->LOAD.B.RELOAD= 90000;	   //10ms
	SYSTICK->CTRL.B.ENABLE=1;
	SYSTICK->CTRL.B.TICKINT=1;
	SYSTICK->CTRL.B.CLKSOURCE=0;	//hclk / 8 =9MHz CLK source


	SCB->SHPR3.B.SYSTICK_ = 0X80;
	return 0;
}
/*
 * Name								: SysTick_Handler
 * Description				: ---
 * Author							: XiaomaGee.
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 * 
 * create.
 * --------------------
 */
void SysTick_Handler(void)
{	

	static int key_code_bak = 0;	

	static int touch_counter = 0;	
	
	systick.counter ++;	
	if((systick.counter % 5) ==0)systick.msecond_50_flag = 1;
	if((systick.counter % 50) ==0)systick.msecond_500_flag = 1;
	if((systick.counter % 100) ==0)systick.second_flag = 1;
	if((systick.counter % 6000) == 0)systick.minute_flag = 1;  

	
	//touch	
	if((touch_counter ++ % 10) == 0)
	{
		ads7843.read_key();
	
		if (key_code == key_code_bak || key_code == 0) 
		{
			key_code_bak = key_code;
			return;
		}
		event = key_code;
		key_code_bak = key_code;
	}	
}

