/*
 * FILE								: touch.c
 * DESCRIPTION						: --
 * Author							: XiaomaGee@Gmail.com
 * Copyright						:
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 03/05/2012
 *
 * create.
 * --------------------
 */

// //---------------- include files ------------------------//
#include "..\include\touch.h"
#include "..\include\key.h"

#include <string.h>

//---------------- Function Prototype -------------------//

static int add_node(TOUCH_LL_T *);
static int del_node(int event);
static int clear(void);


//---------------- Variable -----------------------------//

TOUCH_T touch ={
	.add_node = add_node,
	.del_node = del_node,
	.clear = clear

};

TOUCH_LL_T touch_ll ={
	.x0 = 0,
	.y0 = 0,
	.x1 = 0,
	.y1 = 0,
	.event = EVENT_NONE,
	.next = NULL
};

//----------------- linked list rc ----------------------//

TOUCH_LL_T touch_key_a ={
	.x0 = 330,
	.y0 = 225,
	.x1 = 395,
	.y1 = 265,
	.event = EVENT_KEY_A,
	.next = NULL
};
TOUCH_LL_T touch_key_b ={
	.x0 = 405,
	.y0 = 225,
	.x1 = 470,
	.y1 = 265,
	.event = EVENT_KEY_B,
	.next = NULL
};

//-----------------Function------------------------------//

/*
 * Name								: add_node
 * Description						: ---
 * Author							: XiaomaGee.
 *
 * History
 * ----------------------
 * Rev								: 0.00
 * Date								: 03/05/2012
 *
 * create.
 * ----------------------
 */
static int
add_node(TOUCH_LL_T * ll)
{
	TOUCH_LL_T * p = &touch_ll;
	
	while(p -> next != NULL){
		if(p -> event == ll -> event) return -1; //event exist. add node fail...
		p = p -> next; //linked list moved.
	}	
		ll -> next = NULL; //clear linked list end.
		p -> next = ll;
	
	return 0;
}
/*
 * Name								: del_node
 * Description						: ---
 * Author							: XiaomaGee.
 *
 * History
 * ----------------------
 * Rev								: 0.00
 * Date								: 03/05/2012
 *
 * create.
 * ----------------------
 */
static int
del_node(int event)
{
	TOUCH_LL_T * p = &touch_ll;
	TOUCH_LL_T * pper;
	
	while(p != NULL)
	{
		if( p-> event == event)
		{
			pper -> next = p ->next;	
			return 0;
		}
		pper = p;
		p = p -> next;
	} 
	 return -1; //del fail..
}

/*
 * Name								: clear
 * Description						: ---
 * Author							: XiaomaGee.
 *
 * History
 * ----------------------
 * Rev								: 0.00
 * Date								: 03/05/2012
 *
 * create.
 * ----------------------
 */
 static int
 clear(void)
 {
	touch_ll.next = NULL;
	
	return 0;
 }
