/*
 * FILE								: flash.h
 * DESCRIPTION				: This file is iHMI43 W25Q16/64 driver file header
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 *
 * create.
 * --------------------
 */
#ifndef __flash_h__
#define __flash_h__


#define READ_ID						0x9f							
#define EN_WRITE_FLASH		0x06
#define DIS_WRITE_FLASH		0x04
#define	ERASE							0x60
#define	EN_WRITE_REGISTER	0x50
#define WRITE_REGISTER		0x01
#define READ_REGISTER			0x05
#define READ_FLASH				0x03
#define AAI								0xAD
#define UNBUSY_FLAG				0x03
#define READ_FLASH_HS			0x0B
#define SECTOR_ERASE			0X20 

#define PAGE_PROGRAM			0X02


//-----------------Extern Define----------------------//
typedef struct {
	unsigned long int (* read_id)(void);
	int (* writen)(unsigned long int addr,char *buf, int len);
	int (* readn)(unsigned long int addr,char *buf, int len);
}W25QXX_T;


//-----------------Extern functions----------------------//
extern W25QXX_T w25qxx;
#endif //__flash_h__

