/*
 * FILE								: hardware.h
 * DESCRIPTION				: This file is iHMI43 hardware file header.
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 08/26/2012
 *
 * create.
 * --------------------
 */

#ifndef __hardware_h__
#define __hardware_h__

//-----------------Include files------------------------//

#include "..\include\stm32f10x_reg.h"

//----------------- Define -----------------------------//

#define	 BSTOP_OUTPUT	  GPIOA->CRL.B.MODE0=0X3;\
											GPIOA->CRL.B.CNF0=0
											
#define	BSTOP_ON			GPIOA->BSRR.B.SETIO0=1
#define BSTOP_OFF			GPIOA->BSRR.B.CLRIO0=1 											
 
#define	 LED_OUTPUT	  GPIOC->CRL.B.MODE4=0X3;\
											GPIOC->CRL.B.CNF4=0

#define	LED_ON		GPIOC->BSRR.B.SETIO4=1
#define LED_OFF		GPIOC->BSRR.B.CLRIO4=1

#define	 RS485_OUTPUT	  GPIOB->CRL.B.MODE2=0X3;\
												GPIOB->CRL.B.CNF2=0

#define	RS485_T   GPIOB->BSRR.B.SETIO2=1
#define RS485_R   GPIOB->BSRR.B.CLRIO2=1


//DS1302  
#define	DS1302_IO_OUTPUT		GPIOE->CRL.B.MODE0=0X3;\
														GPIOE->CRL.B.CNF0=0
#define	DS1302_IO_INPUT			GPIOE->CRL.B.MODE0=0;\
														GPIOE->CRL.B.CNF0=0X1

#define	DS1302_IO_ON				GPIOE->BSRR.B.SETIO0=1
#define DS1302_IO_OFF				GPIOE->BSRR.B.CLRIO0=1 

#define	DS1302_SCLK_OUTPUT	GPIOE->CRL.B.MODE1=0X3;\
														GPIOE->CRL.B.CNF1=0
#define	DS1302_SCLK_ON			GPIOE->BSRR.B.SETIO1=1
#define DS1302_SCLK_OFF			GPIOE->BSRR.B.CLRIO1=1 

#define	DS1302_RST_OUTPUT		GPIOB->CRL.B.MODE7=0X3;\
														GPIOB->CRL.B.CNF7=0
#define	DS1302_RST_ON				GPIOB->BSRR.B.SETIO7=1
#define DS1302_RST_OFF			GPIOB->BSRR.B.CLRIO7=1 

#define DS1302_IO_DATA			GPIOE->IDR.B.IO0

#define POWER_ON_INPUT      GPIOC->CRL.B.MODE6 = 0; \
														GPIOC->CRL.B.CNF6 = 2;\
														GPIOC->ODR.B.IO6 = 1;
														
#define POWER_ON_DETECT			GPIOC->IDR.B.IO6

#define CAPTURE_INPUT       GPIOC->CRL.B.MODE7 = 0; \
														GPIOC->CRL.B.CNF7 = 2;\
														GPIOC->ODR.B.IO7 = 1;

#define CAPTURE             GPIOC->IDR.B.IO7

#endif //__hardware_h__
















