/*
 * FILE								: i2c.h
 * DESCRIPTION				: This file is iHMI43 i2c file header.
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 * --------------------
 * Rev								:0.00
 * Date								:08/26/2012
 *
 * create.
 * --------------------
 */

//-------------------Define-----------------------------//
#ifndef __i2c_h__
#define __i2c_h__

//-----------------Include files-------------------------//
#define	 SCL_OUTPUT	  	GPIOB->CRH.B.MODE8=0X3;\
					  	GPIOB->CRH.B.CNF8=0X1

#define	 SDA_OUTPUT	  	GPIOB->CRH.B.MODE9=0X3;\
					  	GPIOB->CRH.B.CNF9=0X1

#define	 SDA_INPUT	  	GPIOB->CRH.B.MODE9=0;\
					  	GPIOB->CRH.B.CNF9=0X1
				


//------------------Define-------------------------------//
#define	SCL_ON		GPIOB->BSRR.B.SETIO8=1
#define SCL_OFF		GPIOB->BSRR.B.CLRIO8=1


#define	SDA_ON		GPIOB->BSRR.B.SETIO9=1
#define SDA_OFF		GPIOB->BSRR.B.CLRIO9=1

#define SDA_DATA	GPIOB->IDR.B.IO9


//----------------- Typedef------------------------------//
typedef  struct{
	int (* initialize)(void);
	unsigned char (* read)(void);
	int (* write)(unsigned char data);
	int (* start)(void);
	int (* stop)(void);
	int (* check_ack)(void);
	int (* ack)(char);
	int ack_flag;
	int (* read_nbyte)(unsigned char ,unsigned char ,unsigned char * ,unsigned char);
	int (* write_nbyte)(unsigned char ,unsigned char ,unsigned char *,unsigned char);
 
	}MY_I2C_T;

//----------------- Extern ------------------------------//

extern MY_I2C_T i2c;

#endif //__i2c_h__
